//0x82608EDB // The IEEE 802.3 standard: HD=6 for 172-268; HD=8 for 58-91
//0x8F6E37A0 // Castagnoli (iSCSI): HD=6 for 178-5243; HD=8 for 48-177
//0xBA0DC66B // Koopman: HD=6 for 153-16360; HD=8 for 19-152
//0x90022004 // Koopman: HD=6!!! for 8!!!-32738

//CRC-32 HDLC, ANSI X3.66, ITU-T V.42, Ethernet, Serial ATA, MPEG-2, PKZIP, Gzip, Bzip2, PNG,[24] many others) 	0x04C11DB7 / 0xEDB88320 / 0x82608EDB[10]
//CRC-32C (Castagnoli) iSCSI, SCTP, G.hn payload, SSE4.2, Btrfs, ext4						1EDC6F41 / 0x82F63B78 / 0x8F6E37A0[10]
//CRC-32K (Koopman)												741B8CD7 / 0xEB31D82E / 0xBA0DC66B[10]

/*
E:\Knight-tour_r8dump_Yorikke_CRC8>cl /Ox Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86
Copyright (C) Microsoft Corporation.  All rights reserved.

Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

/out:Knight-tour_r8dump_Yorikke_CRC8.exe
Knight-tour_r8dump_Yorikke_CRC8.obj

E:\Knight-tour_r8dump_Yorikke_CRC8>Knight-tour_r8dump_Yorikke_CRC8.exe a8 10000000
Knight-tour_r8dump_Yorikke, subrevision B, written by Kaze (based on Kurt White's code), downloadable at www.sanmayce.com/Fastest_Hash
Purpose: to compare FNV1A_Yorikke and CRC32 by giving the highest number of collisions i.e. the deepest nest/layer, the-lesser-the-better.
Polynomial used:
#define CRCPOLY 0xEDB88320 // CRC32
#define CRCPOLYC 0x82F63B78 // CRC32C
#define CRCINIT 0xFFFFFFFF
KT to be hashed = 00,010,000,000
HashSizeInBits = 7
ReportAtEvery = 1,000,000
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
FNV1A_Yorikke: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,052; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,051; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,026; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,966; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,897; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,938; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,893; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,730; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,720; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,632; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,652; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,661; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,520; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,395; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,617; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,476; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,406; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,389; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,399; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,169; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,204; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,205; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,166; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,063; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,992; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,937; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,829; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,922; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,942; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,631; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%

E:\Knight-tour_r8dump_Yorikke_CRC8>
*/

#include <windows.h>

#include <stdint.h> // uint8_t needed
//typedef unsigned char uint8_t;
//typedef unsigned short uint16_t;
//typedef unsigned int uint32_t;

#define _rotl_KAZE(x, n) (((x) << (n)) | ((x) >> (32-(n))))

//#define HashSizeInBits 26 //256MB
//#define ReportAtEvery (1<<HashSizeInBits)-1 //1000000

int PrintTheFirstKTvariants=0;

// "There it now stands for ever. Black on white.
// I can't get away from it. Ahoy, Yorikke, ahoy, hoy, ho!
// Go to hell now if you wish. What do I care? It's all the same now to me.
// I am part of you now. Where you go I go, where you leave I leave, when you go to the devil I go. Married.
// Vanished from the living. Damned and doomed. Of me there is not left a breath in all the vast world.
// Ahoy, Yorikke! Ahoy, hoy, ho!
// I am not buried in the sea,
// The death ship is now part of me
// So far from sunny New Orleans
// So far from lovely Louisiana."
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
// 
// "Walking home to our good old Yorikke, I could not help thinking of this beautiful ship, with a crew on board that had faces as if they were seeing ghosts by day and by night.
// Compared to that gilded Empress, the Yorikke was an honorable old lady with lavender sachets in her drawers.
// Yorikke did not pretend to anything she was not. She lived up to her looks. Honest to her lowest ribs and to the leaks in her bilge.
// Now, what is this? I find myself falling in love with that old jane.
// All right, I cannot pass by you, Yorikke; I have to tell you I love you. Honest, baby, I love you.
// I have six black finger-nails, and four black and green-blue nails on my toes, which you, honey, gave me when necking you.
// Grate-bars have crushed some of my toes. And each finger-nail has its own painful story to tell.
// My chest, my back, my arms, my legs are covered with scars of burns and scorchings.
// Each scar, when it was being created, caused me pains which I shall surely never forget.
// But every outcry of pain was a love-cry for you, honey.
// You are no hypocrite. Your heart does not bleed tears when you do not feel heart-aches deeply and truly.
// You do not dance on the water if you do not feel like being jolly and kicking chasers in the pants.
// Your heart never lies. It is fine and clean like polished gold. Never mind the rags, honey dear.
// When you laugh, your whole soul and all your body is laughing.
// And when you weep, sweety, then you weep so that even the reefs you pass feel like weeping with you.
// I never want to leave you again, honey. I mean it. Not for all the rich and elegant buckets in the world.
// I love you, my gypsy of the sea!"
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
uint32_t FNV1A_Hash_Yorikke(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    const char *p = str;

    for(; wrdlen >= 2*2*sizeof(uint32_t); wrdlen -= 2*2*sizeof(uint32_t), p += 2*2*sizeof(uint32_t)) {
        hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
        hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
    }

    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t FNV1A_Hash_YoshimitsuTRIADii(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 24) {
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t FNV1A_Hash_YoshimitsuTRIAD(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    //uint32_t hash32D = 2166136261;
    const char *p = str;

    for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        
		//hash32D = (hash32D ^ (_rotl(*(uint32_t *)(p+24),5) ^ *(uint32_t *)(p+28))) * PRIME;        

/*
// Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86 gave this:
// 12d-0f4+2= 59 bytes, No CARAMBA anymore.
$LL9@FNV1A_Hash@2:

; 160  : 		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  000f4	8b 01		 mov	 eax, DWORD PTR [ecx]
  000f6	c1 c0 05	 rol	 eax, 5
  000f9	33 41 04	 xor	 eax, DWORD PTR [ecx+4]
  000fc	83 eb 18	 sub	 ebx, 24			; 00000018H
  000ff	33 f0		 xor	 esi, eax

; 161  : 		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  00101	8b 41 08	 mov	 eax, DWORD PTR [ecx+8]
  00104	69 f6 e7 d3 0a
	00		 imul	 esi, 709607		; 000ad3e7H
  0010a	c1 c0 05	 rol	 eax, 5
  0010d	33 41 0c	 xor	 eax, DWORD PTR [ecx+12]
  00110	83 c1 18	 add	 ecx, 24			; 00000018H
  00113	33 f8		 xor	 edi, eax

; 162  : 		hash32C = (hash32C ^ (_rotl(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  00115	8b 41 f8	 mov	 eax, DWORD PTR [ecx-8]
  00118	69 ff e7 d3 0a
	00		 imul	 edi, 709607		; 000ad3e7H
  0011e	c1 c0 05	 rol	 eax, 5
  00121	33 41 fc	 xor	 eax, DWORD PTR [ecx-4]
  00124	33 e8		 xor	 ebp, eax
  00126	69 ed e7 d3 0a
	00		 imul	 ebp, 709607		; 000ad3e7H
  0012c	4a		 dec	 edx
  0012d	75 c5		 jne	 SHORT $LL9@FNV1A_Hash@2
*/

/*
// Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011 gave this:
// 216a-212f+2= 61 bytes, No CARAMBA anymore.
;;;     for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {

  02127 83 fa 18         cmp edx, 24                            
  0212a 72 43            jb .B4.5 ; Prob 10%                    
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.2:                          ; Preds .B4.1
  0212c 89 34 24         mov DWORD PTR [esp], esi               ;
                                ; LOE eax edx ecx ebx ebp edi
.B4.3:                          ; Preds .B4.2 .B4.3

;;; 		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  0212f 8b 31            mov esi, DWORD PTR [ecx]               
  02131 83 c2 e8         add edx, -24                           
  02134 c1 c6 05         rol esi, 5                             
  02137 33 71 04         xor esi, DWORD PTR [4+ecx]             
  0213a 33 de            xor ebx, esi                           

;;; 		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  0213c 8b 71 08         mov esi, DWORD PTR [8+ecx]             
  0213f c1 c6 05         rol esi, 5                             
  02142 33 71 0c         xor esi, DWORD PTR [12+ecx]            
  02145 33 fe            xor edi, esi                           

;;; 		hash32C = (hash32C ^ (_rotl(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  02147 8b 71 10         mov esi, DWORD PTR [16+ecx]            
  0214a c1 c6 05         rol esi, 5                             
  0214d 33 71 14         xor esi, DWORD PTR [20+ecx]            
  02150 83 c1 18         add ecx, 24                            
  02153 33 ee            xor ebp, esi                           
  02155 69 db e7 d3 0a 
        00               imul ebx, ebx, 709607                  
  0215b 69 ff e7 d3 0a 
        00               imul edi, edi, 709607                  
  02161 69 ed e7 d3 0a 
        00               imul ebp, ebp, 709607                  
  02167 83 fa 18         cmp edx, 24                            
  0216a 73 c3            jae .B4.3 ; Prob 82%                   
                                ; LOE eax edx ecx ebx ebp edi
.B4.4:                          ; Preds .B4.3
  0216c 8b 34 24         mov esi, DWORD PTR [esp]               ;
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.5:                          ; Preds .B4.1 .B4.4
*/

    }
	if (p != str) {
		hash32 = (hash32 ^ _rotl(hash32C,5) ) * PRIME;
		//hash32B = (hash32B ^ _rotl(hash32D,5) ) * PRIME;
	}

    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t FNV1A_Hash_Yoshimura(const char *str, SIZE_T wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 2*2*sizeof(uint32_t)) {
    Second_Line_Offset = wrdlen-((wrdlen>>4)+1)*(2*4); // ((wrdlen>>1)>>3)
    Loop_Counter = (wrdlen>>4);
    //if (wrdlen%16) Loop_Counter++;
    Loop_Counter++;
    for(; Loop_Counter; Loop_Counter--, p += 2*sizeof(uint32_t)) {
		// revision 1:
		//hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		//hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+0+Second_Line_Offset),5) ^ *(uint32_t *)(p+4+Second_Line_Offset))) * PRIME;        
		// revision 2:
		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
    }
} else {
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

// CRC_SlicingBy8

#define CRCPOLYK1 0xBA0DC66B //CRC-32K_0xBA0DC66B
#define CRCPOLYK2 0x90022004 //CRC-32K_0x90022004

#define CRCPOLYC1 0x82F63B78 //CRC-32C_0x82F63B78
#define CRCPOLYC2 0x8F6E37A0 //CRC-32C_0x8F6E37A0

//(0x82F63B78 vs 0xEDB88320)
#define CRCPOLYC 0x82F63B78
#define CRCPOLY 0xEDB88320
#define CRCINIT 0xFFFFFFFF
 
uint32_t g_crc_slicingK1[8][256];
uint32_t g_crc_slicingK2[8][256];
uint32_t g_crc_slicingC1[8][256];
uint32_t g_crc_slicingC2[8][256];
uint32_t g_crc_precalc[4][256]; // CRC-32

static uint32_t Min(uint32_t x, uint32_t y) {
    // Branchless minimum (from http://graphics.stanford.edu/~seander/bithacks.html#IntegerMinOrMax)
    //return y ^ ((x ^ y) & -(x < y));
     return (x < y) ? x : y; // CMOV is used when /arch:SSE2 is on
}

static void CRC_SlicingInitK1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK1 & (-(int)(x & 1)));
		g_crc_slicingK1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitK2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK2 & (-(int)(x & 1)));
		g_crc_slicingK2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK2[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC1 & (-(int)(x & 1)));
		g_crc_slicingC1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC2 & (-(int)(x & 1)));
		g_crc_slicingC2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC2[j][i] = c;
		}
	}
}


uint32_t CRC_SlicingBy8K1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK1[7][(crc      ) & 0xFF] ^
			g_crc_slicingK1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK1[4][(crc >> 24)] ^
			g_crc_slicingK1[3][(next      ) & 0xFF] ^
			g_crc_slicingK1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8K2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK2[7][(crc      ) & 0xFF] ^
			g_crc_slicingK2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK2[4][(crc >> 24)] ^
			g_crc_slicingK2[3][(next      ) & 0xFF] ^
			g_crc_slicingK2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC1[7][(crc      ) & 0xFF] ^
			g_crc_slicingC1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC1[4][(crc >> 24)] ^
			g_crc_slicingC1[3][(next      ) & 0xFF] ^
			g_crc_slicingC1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC2[7][(crc      ) & 0xFF] ^
			g_crc_slicingC2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC2[4][(crc >> 24)] ^
			g_crc_slicingC2[3][(next      ) & 0xFF] ^
			g_crc_slicingC2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


// CRC-32
//#define CRCPOLY 0xEDB88320
//#define CRCINIT 0xFFFFFFFF

void CRC32Init(void) {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for(i = 0; i <= 0xFF; i++) {
		x = i;
		for(j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLY & (-(int)(x & 1)));
		g_crc_precalc[0][i] = x;
	}

	for(i = 0; i <= 0xFF; i++) {
		c = g_crc_precalc[0][i];
		for(j = 1; j < 4; j++) {
			c = g_crc_precalc[0][c & 0xFF] ^ (c >> 8);
			g_crc_precalc[j][i] = c;
		}
	}
}

uint32_t CRC32(const char* key, uint32_t len) {
	uint32_t crc = CRCINIT;
	uint32_t ndwords = len / sizeof(uint32_t);
uint32_t c;
	for(; ndwords; ndwords--) {
		crc ^= *(uint32_t*)key;
		crc =
			g_crc_precalc[3][(crc      ) & 0xFF] ^
			g_crc_precalc[2][(crc >>  8) & 0xFF] ^
			g_crc_precalc[1][(crc >> 16) & 0xFF] ^
			g_crc_precalc[0][(crc >> 24) & 0xFF];
		key += sizeof(uint32_t);
	}
	if (len & sizeof(uint16_t)) {
		c = crc ^ *(uint16_t*)key;
		crc = g_crc_precalc[1][(c     ) & 0xFF] ^
			  g_crc_precalc[0][(c >> 8) & 0xFF] ^ (crc >> 16);
		key += sizeof(uint16_t);
	}
	//if (len & sizeof(BYTE))
	if (len & 1)
		crc = g_crc_precalc[0][(crc ^ *key) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


void x64toaKAZE (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEzerocommaBINARY (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[105] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[105-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 4 == 0)
                            { txpman++;
                              buf[105-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[105-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 4 == 0)
                            { txpman++;
                              buf[105-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 105);
        return buf;
}



char * _ui64toaKAZEcomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}



#define _WIN32_ENVIRONMENT_
//#define _POSIX_ENVIRONMENT_

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#if defined(_WIN32_ENVIRONMENT_)
#include <io.h> // needed for Windows' 'lseeki64' and 'telli64'
//Above line must be commented in order to compile with Intel C compiler: an error "can't find io.h" occurs.
#else
#endif /* defined(_WIN32_ENVIRONMENT_)  */


clock_t start,finish;
double duration;

  char llTOaDigits[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits1[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits2[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits3[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits4[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits5[105]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  unsigned long long wincount = 0;
  unsigned long long Sequences = 0, Jumps = 0;
  int Verbose=0;
  #define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )
  #define KAZE_tolower(c) ( (((c) >= 'A') && ((c) <= 'Z')) ? ((c) - 'A' + 'a') : (c) )
  char Bunyo1, Bunyo2;
  //int KT;
  unsigned long long KT;

#define MaxLineLength 1024*1024 // crlf
char *wrd, *wrdUNALIGN;

      char *pointerflush, *pointerflushUNALIGN;
      char *pointerflush0, *pointerflushUNALIGN0;
      char *pointerflush1, *pointerflushUNALIGN1;
      char *pointerflush2, *pointerflushUNALIGN2;
      char *pointerflush3, *pointerflushUNALIGN3;
      char *pointerflush4, *pointerflushUNALIGN4;
      char *pointerflush5, *pointerflushUNALIGN5;
      unsigned long memory_size;
      uint32_t Slot;
      char KTstring[128+1]; 
      char KTstringBRUTUS[128+1]; 
      uint32_t PseudoLinkedPointer=0;
      uint32_t MAXcollisionsAtSomeSlots=0;
      uint32_t MAXcollisionsAtSomeSlots0=0;
      uint32_t MAXcollisionsAtSomeSlots1=0;
      uint32_t MAXcollisionsAtSomeSlots2=0;
      uint32_t MAXcollisionsAtSomeSlots3=0;
      uint32_t MAXcollisionsAtSomeSlots4=0;
      uint32_t MAXcollisionsAtSomeSlots5=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM0=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM1=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM2=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM3=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM4=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM5=0;
      uint32_t HASHfreeSLOTS;
      uint32_t HASHfreeSLOTS0;
      uint32_t HASHfreeSLOTS1;
      uint32_t HASHfreeSLOTS2;
      uint32_t HASHfreeSLOTS3;
      uint32_t HASHfreeSLOTS4;
      uint32_t HASHfreeSLOTS5;
      uint32_t HASHcollisionsSLOTS;
      uint32_t HASHcollisionsSLOTS0;
      uint32_t HASHcollisionsSLOTS1;
      uint32_t HASHcollisionsSLOTS2;
      uint32_t HASHcollisionsSLOTS3;
      uint32_t HASHcollisionsSLOTS4;
      uint32_t HASHcollisionsSLOTS5;
      uint64_t KT_DumpCounter=0;

   int BrutusLet;
   int BrutusPos;
   int BrutusBIN;
   unsigned long long QUADR;
   unsigned long long QUADRlast=0;
   unsigned int KeysvsSlots=0;
   unsigned int STEP64=111111111;


FILE *fp_inLINE;
FILE *fp_outLINE;

      char workK[1024*128];
      long workKoffset = -1;

unsigned long LongestLine;
unsigned long ShortestLine;
unsigned long DumpedLines=0;
unsigned long DumpedLinesOLD=0;

unsigned long long FilesLEN;
unsigned long k, k2, k3, LINE10len, LINE10len2, wrdlen;
unsigned long long NumberOfLines;
unsigned long size_in, size_in2;

#if defined(_WIN32_ENVIRONMENT_)
      unsigned long long size_inLINESIXFOUR;
#else
      size_t size_inLINESIXFOUR;
#endif /* defined(_WIN32_ENVIRONMENT_)  */

char LINE10[257]; // 000..255, 256 = 0
char LINE10_2[257];

//#define MaxLineLength 990123 // crlf
//char wrd[MaxLineLength+1+1]; // crlf
char workbyte;

unsigned long long int i;
unsigned int j;

unsigned int HashSizeInBits;

int main(int argc, char *argv[])
{

printf( "YoYo - [CR]LF lines hasher, r.1 copyleft Kaze.\n" );
printf( "Note: Incoming textual file can exceed 4GB and lines can be up to %d chars long.\n", MaxLineLength );
if (argc != 3) { printf( "Usage: YoYo TextualFile HashSizeInBits\n" ); return( 2 ); }

HashSizeInBits = atoi(argv[2]);

if( ( fp_inLINE = fopen( argv[1], "rb" ) ) == NULL )
{ printf( "YoYo: Can't open file %s \n", argv[1] ); return( 1 ); }

//fseek( fp_inLINE, 0L, SEEK_END );  //Rev. 12
//size_inLINE = ftell( fp_inLINE );  //Rev. 12
//fseek( fp_inLINE, 0L, SEEK_SET );  //Rev. 12

#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp_inLINE), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp_inLINE) );
_lseeki64( fileno(fp_inLINE), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp_inLINE, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp_inLINE );
fseeko( fp_inLINE, 0L, SEEK_SET );
#endif /* defined(_WIN32_ENVIRONMENT_)  */




// zzzzzz [
printf("Polynomial(s) used:\n");
//printf("CRC32C1_8slice: 0x82F63B78 \n");
printf("CRC32C2_8slice: 0x8F6E37A0 \n");
//printf("CRC32K1_8slice: 0xBA0DC66B \n");
//printf("CRC32K2_8slice: 0x90022004 \n");

//printf("KT to be hashed = %s\n", _ui64toaKAZEcomma(KT, llTOaDigits, 10));
printf("HashSizeInBits = %s\n", _ui64toaKAZEcomma(HashSizeInBits, llTOaDigits, 10));
//printf("ReportAtEvery = %s\n", _ui64toaKAZEcomma(ReportAtEvery, llTOaDigits, 10));


memory_size = MaxLineLength + 1 + 64 +1+1; //crlf
printf( "Allocating KEY memory %luKB ... ", (memory_size>>10) );
wrdUNALIGN = (char *)malloc( memory_size );
if( wrdUNALIGN == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
wrd = wrdUNALIGN + 64 - (((size_t)wrdUNALIGN) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(wrd, 0, memory_size);



/*
memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN = (char *)malloc( memory_size );
if( pointerflushUNALIGN == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush, 0, (1<<HashSizeInBits)*sizeof(uint32_t));
*/

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN1 = (char *)malloc( memory_size );
if( pointerflushUNALIGN1 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush1 = pointerflushUNALIGN1 + 64 - (((size_t)pointerflushUNALIGN1) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush1, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

/*

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN2 = (char *)malloc( memory_size );
if( pointerflushUNALIGN2 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush2 = pointerflushUNALIGN2 + 64 - (((size_t)pointerflushUNALIGN2) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush2, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN3 = (char *)malloc( memory_size );
if( pointerflushUNALIGN3 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush3 = pointerflushUNALIGN3 + 64 - (((size_t)pointerflushUNALIGN3) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush3, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN4 = (char *)malloc( memory_size );
if( pointerflushUNALIGN4 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush4 = pointerflushUNALIGN4 + 64 - (((size_t)pointerflushUNALIGN4) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush4, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

*/

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN5 = (char *)malloc( memory_size );
if( pointerflushUNALIGN5 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush5 = pointerflushUNALIGN5 + 64 - (((size_t)pointerflushUNALIGN5) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush5, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN0 = (char *)malloc( memory_size );
if( pointerflushUNALIGN0 == NULL )
{ puts( "\nYoYo: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush0 = pointerflushUNALIGN0 + 64 - (((size_t)pointerflushUNALIGN0) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush0, 0, (1<<HashSizeInBits)*sizeof(uint32_t));

// ]

//CRC32Init();
//CRC_SlicingInit();
CRC_SlicingInitK1();
CRC_SlicingInitK2();
CRC_SlicingInitC1();
CRC_SlicingInitC2();
// zzzzzz ]

printf("Hashing all the LF ending lines encountered in %s bytes long file ...\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits2, 10));
start = clock();
ShortestLine=MaxLineLength;

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	FilesLEN = FilesLEN + size_inLINESIXFOUR;
	wrdlen = 0;
        for( i = 0; i < size_inLINESIXFOUR; i++ )
	{

                // ~~~~~~~~~~~~ Buffering fread, 10x faster [
                if (workKoffset == -1) {
                        if (i + 1024*128 < size_inLINESIXFOUR) {
                                fread( &workK[0], 1, 1024*128, fp_inLINE );
                                workKoffset = 0;
                                workbyte = workK[workKoffset];
                        } else 
                        fread( &workbyte, 1, 1, fp_inLINE );
                } else {
                        workKoffset++;
                        workbyte = workK[workKoffset];
                        if (workKoffset == 1024*128 - 1) workKoffset = -1;
                }
                // ~~~~~~~~~~~~ Buffering fread, 10x faster ]
               
                // ~~~~~~~~~~~~ UnBuffered fread, 10x slower [
                        //fread( &workbyte, 1, 1, fp_inLINE );
                // ~~~~~~~~~~~~ UnBuffered fread, 10x slower ]

                        if( wrdlen < MaxLineLength +1+1)
                        { wrd[ wrdlen ] = workbyte; }

                        if (workbyte == 10) {NumberOfLines++;
			    if (0 < wrdlen && wrd[wrdlen-1]==13) --wrdlen;
                            if (wrdlen > LongestLine) LongestLine=wrdlen;
                            if (wrdlen < ShortestLine) ShortestLine=wrdlen;
// Wildcard search [
                        if ( 0 < wrdlen && wrdlen < MaxLineLength +1+1)
			{
                            wrd[ wrdlen ] = 0;
			    //printf("%s\n", wrd);

// ============================ [ HASHING MUMBO-JUMBO ] ============================ [

		//memcpy( KTstringBRUTUS, wrd, wrdlen );
		KT_DumpCounter++;

//	Slot = ( FNV1A_Hash_Yorikke(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;
//
//	memcpy( &PseudoLinkedPointer, pointerflush+Slot, 4 );
//	PseudoLinkedPointer++;
//	memcpy( pointerflush+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( FNV1A_Hash_Yoshimura(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush0+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush0+Slot, &PseudoLinkedPointer, 4 );


	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush1+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush1+Slot, &PseudoLinkedPointer, 4 );

/*
	Slot = ( CRC_SlicingBy8K1(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush2+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush2+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8K2(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush3+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush3+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8C1(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush4+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush4+Slot, &PseudoLinkedPointer, 4 );
*/

	Slot = ( CRC_SlicingBy8C2(wrd, wrdlen) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush5+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush5+Slot, &PseudoLinkedPointer, 4 );

// ============================ [ HASHING MUMBO-JUMBO ] ============================ ]


			}
// Wildcard search ]
                            wrdlen = 0;
                        }
                        else wrdlen++;
        } // i 'for'
        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

fclose( fp_inLINE );


	HASHfreeSLOTS = 0;
	HASHfreeSLOTS0 = 0;
	HASHfreeSLOTS1 = 0;
	HASHfreeSLOTS2 = 0;
	HASHfreeSLOTS3 = 0;
	HASHfreeSLOTS4 = 0;
	HASHfreeSLOTS5 = 0;

HASHcollisionsSLOTS = 0;
HASHcollisionsSLOTS0 = 0;
HASHcollisionsSLOTS1 = 0;
HASHcollisionsSLOTS2 = 0;
HASHcollisionsSLOTS3 = 0;
HASHcollisionsSLOTS4 = 0;
HASHcollisionsSLOTS5 = 0;

	MAXcollisionsAtSomeSlotsSUM = 0;
	MAXcollisionsAtSomeSlotsSUM0 = 0;
	MAXcollisionsAtSomeSlotsSUM1 = 0;
	MAXcollisionsAtSomeSlotsSUM2 = 0;
	MAXcollisionsAtSomeSlotsSUM3 = 0;
	MAXcollisionsAtSomeSlotsSUM4 = 0;
	MAXcollisionsAtSomeSlotsSUM5 = 0;
	//if ( (KT_DumpCounter & ReportAtEvery) == ReportAtEvery ) {
	printf("Keys vs Slots ratio: %s:1 or %s:%s\n", _ui64toaKAZEcomma(KT_DumpCounter/(1<<HashSizeInBits), llTOaDigits1, 10), _ui64toaKAZEcomma(KT_DumpCounter, llTOaDigits2, 10), _ui64toaKAZEcomma((1<<HashSizeInBits), llTOaDigits3, 10));
		for (j = 0; j < 1<<HashSizeInBits; j++) {
//			memcpy( &PseudoLinkedPointer, pointerflush+((j)<<2), 4 );
//			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS++;
//			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlots = PseudoLinkedPointer;

			memcpy( &PseudoLinkedPointer, pointerflush0+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS0++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots0 ) MAXcollisionsAtSomeSlots0 = PseudoLinkedPointer;

			memcpy( &PseudoLinkedPointer, pointerflush1+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS1++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots1 ) MAXcollisionsAtSomeSlots1 = PseudoLinkedPointer;
/*
			memcpy( &PseudoLinkedPointer, pointerflush2+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS2++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlots2 = PseudoLinkedPointer;

			memcpy( &PseudoLinkedPointer, pointerflush3+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS3++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlots3 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush4+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS4++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlots4 = PseudoLinkedPointer;
*/
			memcpy( &PseudoLinkedPointer, pointerflush5+((j)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS5++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlots5 = PseudoLinkedPointer;
		}


		for (j = 0; j < 1<<HashSizeInBits; j++) {
//			memcpy( &PseudoLinkedPointer, pointerflush+((j)<<2), 4 );
//			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlotsSUM++;

			memcpy( &PseudoLinkedPointer, pointerflush0+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots0 ) MAXcollisionsAtSomeSlotsSUM0++;
			if (PseudoLinkedPointer > 1 ) HASHcollisionsSLOTS0 += PseudoLinkedPointer-1;

			memcpy( &PseudoLinkedPointer, pointerflush1+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots1 ) MAXcollisionsAtSomeSlotsSUM1++;
			if (PseudoLinkedPointer > 1 ) HASHcollisionsSLOTS1 += PseudoLinkedPointer-1;

/*
			memcpy( &PseudoLinkedPointer, pointerflush2+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlotsSUM2++;
			memcpy( &PseudoLinkedPointer, pointerflush3+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlotsSUM3++;
			memcpy( &PseudoLinkedPointer, pointerflush4+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlotsSUM4++;
*/
			memcpy( &PseudoLinkedPointer, pointerflush5+((j)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlotsSUM5++;
			if (PseudoLinkedPointer > 1 ) HASHcollisionsSLOTS5 += PseudoLinkedPointer-1;
		}
	//printf("FNV1A_Yorikke           : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("FNV1A_Yoshimura         : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%; Collisions = %s\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM0, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots0, llTOaDigits2, 10)+(26-13), _ui64toaKAZEzerocomma(HASHfreeSLOTS0, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS0)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3), _ui64toaKAZEzerocomma(HASHcollisionsSLOTS0, llTOaDigits1, 10)+(26-13) );
	printf("FNV1A_YoshimitsuTRIADii : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%; Collisions = %s\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM1, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots1, llTOaDigits2, 10)+(26-13), _ui64toaKAZEzerocomma(HASHfreeSLOTS1, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS1)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3), _ui64toaKAZEzerocomma(HASHcollisionsSLOTS1, llTOaDigits1, 10)+(26-13) );

/*
	printf("CRC32K1_8slice        : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM2, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots2, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS2, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS2)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("CRC32K2_8slice        : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM3, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots3, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS3, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS3)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );

	printf("CRC32C1_8slice        : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM4, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots4, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS4, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS4)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
*/
	printf("CRC32C2_8slice          : Keys = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%; Collisions = %s\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM5, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots5, llTOaDigits2, 10)+(26-13), _ui64toaKAZEzerocomma(HASHfreeSLOTS5, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS5)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3), _ui64toaKAZEzerocomma(HASHcollisionsSLOTS5, llTOaDigits1, 10)+(26-13) );
	//}


	printf("Physical Lines: %s\n", _ui64toaKAZEcomma(KT_DumpCounter, llTOaDigits2, 10));
	printf("Shortest Line : %s\n", _ui64toaKAZEcomma(ShortestLine, llTOaDigits2, 10));
	printf("Longest Line  : %s\n", _ui64toaKAZEcomma(LongestLine, llTOaDigits2, 10));

	finish = clock();
	duration = (double) (finish - start);
	printf("Performance: %.3f bytes per clock\n", (double)size_inLINESIXFOUR/duration);
free(wrdUNALIGN);
free(pointerflushUNALIGN1);
free(pointerflushUNALIGN5);
free(pointerflushUNALIGN0);
	exit(1);

}

